<template>
  <div class="home--container">
    <Modal
      v-if="showResume"
      :data="itemsToPurchase"
      @close-modal="closeModal" 
      />
    <div class="row--left">
      <input
        class="home--container__search"
        v-model="filters.name.value"
        type="text"
        placeholder="Buscar por nombre">
    </div>
    <div class="container--main">
      <aside>
        <Filters
          :data="metaFilters"
          @filter="applyFilter"
        />
      </aside>
      <main class="center">
        <div class="table--container">
          <ul>
            <li
              v-for="(item, index) in filteredItems"
              :key="index">
            <Item
              :id="index"
              @show-item="show"
              @add="add"
              @rest="rest"
              :data="item" 
            />
            </li>
          </ul>
          <button class="btn mt-2" @click="confirmPurchase">Confirmar</button>
        </div>
      </main>
    </div>
  </div>
</template>

<script>
import api from '@/core/services/api.js'
import Item from '@/components/Item.vue'
import Modal from '@/components/templates/Modal.vue'
import Filters from '@/components/organisms/Filters.vue'
import metaFilters from '@/core/utils/filters.js'

export default {
  name: 'Main',
  components: {
    Item,
    Filters,
    Modal
  },
  data() {
    return {
      items:[],
      filteredItems: [],
      filters: {
        order: {value: ''},
        show: {value: ''},
        category: {value: ''},
        name: {value: ''}
      },
      search: '',
      showResume: false
    }
  },
  methods: {
    confirmPurchase() {
      if (this.itemsToPurchase.length === 0) {
        return
      }
      this.showResume = true
    },
    closeModal() {
      this.showResume = false
    },
    show(id) {
      this.items[id].add = true
    },
    add(id) {
      const val = this.items[id].items
      if (val >= this.items[id].stock) {
        return
      }
      this.items[id].items = val + 1
    },
    rest(id) {
      const val = this.items[id].items
      if (val === 1){
        return
      }
      this.items[id].items = val - 1
    },
    applyFilter(kind, value) {
      this.filters[kind].value = value
    }
  },
  computed: {
    metaFilters() {
      return metaFilters
    },
    itemsToPurchase() {
      return this.filteredItems.filter(item => item.add)
    }
  },
  watch: {
    search: function (val) {
      console.log(val)
    },
    filters: {
      deep: true,
      handler (val) {
        this.filteredItems = this.items
        let filtersToApply = []
        
        Object.entries(val).forEach(key => {
          if (key[1].value !== '') {
            filtersToApply.push(key)
          }
        })
        filtersToApply.forEach(item => {
          switch(item[0]) {
            case 'name':
              this.filteredItems = this.filteredItems.filter(item => item.name.toLowerCase().includes(val.name.value.toLowerCase()))
              break;
            case 'show':
              if (val.show.value.toLowerCase() === 'hidden') {
                this.filteredItems = this.filteredItems.filter(item => item.stock > 0)
              }
              break;
            case 'category':
              this.filteredItems = this.filteredItems.filter(item => item.category.toLowerCase() === val.category.value.toLowerCase())
              break;
            case 'order':
              this.filteredItems.sort((a, b) => a[val.order.value] > b[val.order.value] ? 1 : -1);
              break;
            default:
              break;
          }
        })
      }
    }
  },
  created() {
    let tempValues = []
    api.getItems()
      .then(data => {
        tempValues = data.data.products
        tempValues.forEach(item => {
          item.items = 1
          item.add = false
          this.items.push(item)
          this.filteredItems.push(item)
        })
      })
  }
}
</script>

<style lang="sass" scoped>
.home--container
  padding-top: 2rem
  background: #f8f8f8
  height: calc(100% - 2rem)
  width: 100%
  margin-top: 3px
  display: block
  .home--container__search
    height: 40px
    padding: .2rem .8rem
    border-radius: 1rem
    border: 1px solid gray
    font-size: 1.4rem
  .container--main
    display: grid
    grid-template-columns: 300px 1fr
    aside
      height: 100%
    .table--container
      background: #fff
      width: 1080px
      padding-bottom: 1rem
      margin-bottom: 3rem
      box-shadow: 3px 3px 5px rgba(0,0,0,.3)
      ul
        list-style: none
        margin: 0
        padding: 40px
        text-align: -webkit-center
        li
          border-bottom: 2px solid #ebebeb
    main
      overflow-y: scroll
.mt-2
  margin-top: 2rem
.btn
  border: 0;
  border-radius: 4px;
  box-shadow: 3px 3px 5px #afafaf;
  color: #8f8f8f;
  font-weight: bold;
  height: 50px;
  width: 180px;
  font-size: 1rem;
  cursor: pointer;
  background: #fff;
  &:hover
    background: #5fd080
    color: #fff
.row--left
  display: flex
  padding: 0 0 3rem 3rem
</style>